#ifndef _SFDS_H_
#define _SFDS_H_ 1

/* We start remapping SOCKETs into the fd space at this offset (0 index from this num) */
#define SFD_SOCKET_BASE	128

/* For an sfd (either a real fd or a re-mapped SOCKET), tell if it is an FD */
#define SFD_IS_REAL_FD(sfd)	(sfd < SFD_SOCKET_BASE)
#define SFD_IS_SOCKET(sfd) (sfd >= SFD_SOCKET_BASE)

/* Types */
typedef int sfd_type;
#define SFD_TYPE_NONE	0
#define SFD_TYPE_FD		1
#define	SFD_TYPE_SOCKET	2

/* For a real fd or SOCKET, allocate an sfd (will be the same for real fds) */
int allocate_sfd(int fd_or_socket);

/* Free an sfd from the map */
void free_sfd(int sfd);

/* I don't think this is needed */
#if 0
/* For a real fd or SOCKET, get our sfd (will be the same for real fds) */
int real_to_sfd(int fd_or_socket);
#endif

/* For an sfd, get the real handle behind it */
int sfd_to_real(int sfd, sfd_type *type);

#endif
