#ifndef SUPPORT_WIN32_H
#define SUPPORT_WIN32_H 1

#if defined(_MSC_VER) && defined(DEBUG_DRIVER_WIN32)
#define debug_printf(a, ...) printf(a "\n", __VA_ARGS__)
#else
#define debug_printf(a, ...) 
#endif
#define system_printf(a, ...)
#define set_errno(a)


#ifdef __cplusplus
extern "C"
{
#endif
typedef void * audio_out_ptr;

audio_out_ptr
audio_out_new();

audio_out_ptr
audio_out_get_ptr();

int
audio_out_parsewav(audio_out_ptr ptr, const char **ppData, int *pnBytes,
					 int rate, int bits, int channels);

int
audio_out_start(audio_out_ptr ptr);

void
audio_out_stop(audio_out_ptr ptr, int immediately);

int
audio_out_write (audio_out_ptr ptr, const char *pSampleData, int nBytes);


extern int audioformat_;
extern int audiofreq_;
extern int audiobits_;
extern int audiochannels_;
extern int open_flags_;



int ioctl (unsigned int cmd, void *ptr);

#ifdef __cplusplus
};
#endif

#ifdef O_RDONLY
#undef O_RDONLY
#endif
#ifdef O_WRONLY
#undef O_WRONLY
#endif
#ifdef O_RDWR
#undef O_RDWR
#endif

#define	O_ACCMODE	(O_RDONLY|O_WRONLY|O_RDWR)
#define	O_RDONLY	0		/* +1 == FREAD */
#define	O_WRONLY	1		/* +1 == FWRITE */
#define	O_RDWR		2		/* +1 == FREAD|FWRITE */

#define IS_WRITE() ((get_flags() & O_ACCMODE) != O_RDONLY)
#define IS_READ() ((get_flags() & O_ACCMODE) != O_WRONLY)

#define get_flags() open_flags_
#endif
